clear
./sanitize.sh   # It's important to run sanitize.sh because of the object files dependencies
./compileParser.sh

# This compiles the RegSTAB tool and the module regstabBridge, creating regstabBridge.cmx
# (differences from the Batch compilation: we invoke .cmxa instead of .cma and .cmx instead of .cmo)
ocamlopt -rectypes -I ../regstab-2.0.0/_build/src/all -c extString.cmx xmlm.cmx softcore.cmx human.cmx polarity.cmx proposition.cmx indexes.cmx inequality.cmx constraint.cmx literal.cmx connective.cmx openProp.cmx prop.cmx bounds.cmx iteration.cmx flat.cmx schema.cmx helpers.cmx literalset.cmx model.cmx purity.cmx atomicSchemaSet.cmx schemaSet.cmx proof.cmx preProof.cmx ruleApplication.cmx node.cmx lemmas.cmx expandNode.cmx atomicSchemaSet.cmx regstab.cmx ../regstab-2.0.0/regstabBridge.ml

ocamlopt -c module_SetBuilder.ml
ocamlopt -c module_String2FloatMap.ml
ocamlfind ocamlopt -rectypes -I ../regstab-2.0.0 -package batteries -package batteries.syntax -syntax camlp4o -c regstabBridge.cmx module_KatExpressions.ml
# This creates parser.cmx; -rectypes is needed bc parser.ml depends on module_KatExpressions.cmx, 
# which depends on regstabBridge.cmx, which uses rec. types
ocamlopt -c -rectypes parser.ml
# the following creates lexer.cmx ...
ocamlopt -c -rectypes lexer.ml
ocamlopt -c -rectypes parserPolish.ml
ocamlopt -c -rectypes lexerPolish.ml
ocamlfind ocamlopt -package batteries -package batteries.syntax -syntax camlp4o -c -rectypes module_KatExpressionsPos.ml module_KatExpressionsPos2.ml
ocamlopt -c -rectypes module_LinearKatExps.ml
ocamlopt -c -rectypes module_PairsKatExps.ml
ocamlopt -c -rectypes parserPosition.ml
ocamlopt -c -rectypes parserPolishPosition.ml
ocamlopt -c -rectypes parserAssumptions.ml
ocamlopt -c -rectypes lexerPosition.ml
ocamlopt -c -rectypes lexerPolishPosition.ml
ocamlopt -c -rectypes lexerAssumptions.ml
ocamlopt -c -rectypes module_Utils.ml
ocamlopt -c -rectypes module_PairsActionBexp.ml
ocamlopt -c -rectypes module_PairsPairs.ml
ocamlopt -c -rectypes module_RewriteRules.ml
ocamlfind ocamlopt -rectypes -package batteries -package batteries.syntax -syntax camlp4o -c module_Up2CongruenceSearch.ml
ocamlfind ocamlopt -package batteries -package batteries.syntax -syntax camlp4o -c -rectypes module_NFAGS.ml
ocamlfind ocamlopt -I ../regstab-2.0.0 -package batteries -package batteries.syntax -syntax camlp4o -c -rectypes regstabBridge.cmx equivalenceCheckerPD.ml inclusionCheckerAGS1.ml inclusionCheckerAGS2.ml equivalenceCheckerAGS.ml equivalenceCheckerPDWithAssumptions.ml equivalenceCheckerPDWithAssumptionsUru.ml
ocamlopt -c -rectypes module_CallNFAGSEquivChecker.ml

# all or most of the files here depend on module_KatExpressions, which uses rec. types, so the -rectypes flag is necessary
ocamlfind ocamlopt -I ../regstab-2.0.0 -I ../regstab-2.0.0/_build/src/all -rectypes -o runOpt -package batteries -package batteries.syntax -syntax camlp4o -linkpkg extString.cmx xmlm.cmx softcore.cmx human.cmx polarity.cmx proposition.cmx indexes.cmx inequality.cmx constraint.cmx literal.cmx connective.cmx openProp.cmx prop.cmx bounds.cmx iteration.cmx flat.cmx schema.cmx helpers.cmx literalset.cmx model.cmx purity.cmx atomicSchemaSet.cmx schemaSet.cmx proof.cmx preProof.cmx ruleApplication.cmx node.cmx lemmas.cmx expandNode.cmx regstab.cmx module_SetBuilder.cmx regstabBridge.cmx module_String2FloatMap.cmx module_KatExpressions.cmx parser.cmx lexer.cmx parserPolish.cmx lexerPolish.cmx module_KatExpressionsPos.cmx module_KatExpressionsPos2.cmx module_LinearKatExps.cmx module_PairsKatExps.cmx parserPosition.cmx parserPolishPosition.cmx parserAssumptions.cmx lexerPosition.cmx lexerPolishPosition.cmx lexerAssumptions.cmx module_Utils.cmx module_PairsActionBexp.cmx module_Up2CongruenceSearch.cmx module_NFAGS.cmx module_PairsPairs.cmx module_RewriteRules.cmx inclusionCheckerAGS1.cmx inclusionCheckerAGS2.cmx equivalenceCheckerAGS.cmx module_CallNFAGSEquivChecker.cmx equivalenceCheckerPDWithAssumptions.cmx equivalenceCheckerPDWithAssumptionsUru.cmx equivalenceCheckerPD.cmx main.ml

