
open Module_KatExpressions

module rec MLinearKE : sig
  type t = MKE.atom * int * MKE.ke ;;    
  val unions : SetLinearKE.t list -> SetLinearKE.t
  val map : (t -> t) -> SetLinearKE.t -> SetLinearKE.t 
  val setLinearKEfromList : t list -> SetLinearKE.t
  val concat3rd : MKE.ke -> t -> t
end 
  = struct

    type t = MKE.atom * int * MKE.ke ;;
    
    (* 'unions lst' recursively makes union of all the sets in list 'lst' *)
    let rec unions lst =
      match lst with
	  []		-> SetLinearKE.empty
	| l::ls		-> SetLinearKE.union l (unions ls) ;;
    
    let map foo set = SetLinearKE.fold (fun x -> SetLinearKE.add (foo x)) set SetLinearKE.empty
      
    let rec setLinearKEfromList lst =
      match lst with
	  []       -> SetLinearKE.empty
	| l::ls    -> SetLinearKE.add l (setLinearKEfromList ls)
	  
    (* 'concat3rd exp1 (a,b,exp2)' concats 'exp1' to the end of 'exp2' *)
    let concat3rd exp1 (a,b,exp2) = (a,b,MKE.concat exp1 exp2) ;;

  end
and OrderLinearKE : Set.OrderedType
  = struct
    type t = MLinearKE.t      
    let compare = Pervasives.compare
  end 
and SetLinearKE : Set.S with type elt = MLinearKE.t
  = Set.Make( OrderLinearKE )
