
open Module_KatExpressions

module rec MPairsKE : sig 
  type t = MKE.ke * MKE.ke
  val fromList : t list -> SetPairsKE.t ;;
  val printSetPairsKE : SetPairsKE.t -> unit ;;
  val printSetPairsKE_nl : SetPairsKE.t -> unit ;;
  val setPairsKE2String : SetPairsKE.t -> string ;;
end 
  = struct

    type t = MKE.ke * MKE.ke
	
    let rec fromList lst =
      match lst with
	  []       -> SetPairsKE.empty
	| l::ls    -> SetPairsKE.add l (fromList ls) ;;
    
    let setPairsKE2String set =
      let rec loop set =
	if (SetPairsKE.is_empty set) then "<this set is empty>" else
	  if (SetPairsKE.cardinal set)=1 then
	    let (x,y) = SetPairsKE.min_elt set in
	    "(" ^ (MKE.katExp2String x) ^ "," ^ (MKE.katExp2String y) ^")"
	  else 
	    let (x,y) = SetPairsKE.min_elt set in
	    "(" ^ (MKE.katExp2String x) ^ "," ^ (MKE.katExp2String y) ^")," 
	    ^ (loop (SetPairsKE.remove (x,y) set)) in
      "{" ^ (loop set) ^ "}"

    let printSetPairsKE set = print_string (setPairsKE2String set)
    let printSetPairsKE_nl set = print_endline (setPairsKE2String set)
    
  end
and OrderPairsKE : Set.OrderedType
  = struct
    type t = MPairsKE.t    
    let compare = Pervasives.compare
  end 
and SetPairsKE : Set.S with type elt = MPairsKE.t
  = Set.Make( OrderPairsKE )
