%{

(* OCamls imports and others go here *)
open Module_KatExpressions
exception ERROR of string

(* this parser has some optimizations available, to turn them on
   change the optimizations value to ON below *)
let optimizations = "OFF"

let treatTimes e1 e2 = 
  if optimizations="ON" then
    (if (e1=MKE.(Bexp Zero) || e2=MKE.(Bexp Zero)) then 
      MKE.(Bexp Zero) 
    else if e1=MKE.(Bexp One) then 
      e2 
    else if e2=MKE.(Bexp One) then 
      e1 
    else MKE.buildTimes [e1;e2])
  else MKE.buildTimes [e1;e2]

let treatPlus e1 e2 = 
  if optimizations="ON" then
    if e1=MKE.(Bexp Zero) then e2 else MKE.buildPlus [e1;e2]
  else MKE.buildPlus [e1;e2]

let treatStar e = 
  if optimizations="ON" then
    match e with 
	(MKE.Star e')       -> e 
      | (MKE.Bexp _ ) -> MKE.(Bexp One)
      | otherwise           -> MKE.Star e
  else MKE.Star e

%}

%token P
%token B
%token <int> INT
%token NOT
%token ONE ZERO
%token PLUS STAR
%token TIMES
%token EOL		(* end of the line *)

%start data
%type <MKE.ke list> data

%%

data:
  r=exp ; EOL {[r]}

exp:
| PLUS ; e1=exp ; e2=exp {treatPlus e1 e2}
| TIMES ; e1=exp ; e2=exp {treatTimes e1 e2}
| STAR ; e=exp {treatStar e}
| ONE {MKE.(Bexp One)}
| ZERO {MKE.(Bexp Zero)}
| P ; i=INT {MKE.(Prog i)}
| B ; i=INT {MKE.(Bexp (Test i))}
| NOT ; e = exp {match e with MKE.Bexp f -> MKE.Bexp (MKE.buildNeg f) | otherwise -> raise (ERROR "The negation operator can only be applied to boolean expressions")}
