exception Error

type token = 
  | ZERO
  | TIMES
  | STAR
  | PLUS
  | P
  | ONE
  | NOT
  | INT of (
# 57 "parserPolishPosition.mly"
       (int)
# 15 "parserPolishPosition.ml"
)
  | EOL
  | B

and _menhir_env = {
  _menhir_lexer: Lexing.lexbuf -> token;
  _menhir_lexbuf: Lexing.lexbuf;
  mutable _menhir_token: token;
  mutable _menhir_startp: Lexing.position;
  mutable _menhir_endp: Lexing.position;
  mutable _menhir_shifted: int
}

and _menhir_state = 
  | MenhirState15
  | MenhirState12
  | MenhirState8
  | MenhirState4
  | MenhirState3
  | MenhirState2
  | MenhirState0


# 1 "parserPolishPosition.mly"
  

(* A Parser that distinguishes all action symbols (pi).
   This parser accepts expressions written in Polish notation. *)

(* OCamls imports and others go here *)
open Module_KatExpressionsPos
open Module_KatExpressions
exception ERROR of string

(* This parser has some optimizations available, to turn them on
   change the optimizations value to ON below *)
let optimizations = "OFF"

let treatTimes e1 e2 = 
  if optimizations="ON" then
    (if (e1=MKEPos.(Bexp MKE.Zero) || e2=MKEPos.(Bexp MKE.Zero)) then 
      MKEPos.(Bexp MKE.Zero)
    else if e1=MKEPos.(Bexp MKE.One) then 
      e2
    else if e2=MKEPos.(Bexp MKE.One) then 
      e1 
    else MKEPos.buildTimes [e1;e2])
  else MKEPos.buildTimes [e1;e2]

let treatPlus e1 e2 = 
  if optimizations="ON" then
    if e1=MKEPos.(Bexp MKE.Zero) then e2 else MKEPos.buildPlus [e1;e2]
  else MKEPos.buildPlus [e1;e2]

let rec isBoolean exp = 
  match exp with 
      MKEPos.Bexp _    ->  true
    | MKEPos.Star exp' ->  isBoolean exp'
    | _                ->  false

(* Checks if e is boolean and if so returns 1 *)
let treatStar e = 
  if optimizations="ON" then
    if isBoolean e then MKEPos.(Bexp MKE.One)
    else MKEPos.Star e
  else MKEPos.Star e

let z = ref 1

let incZ () = if !z>0 then z:=(!z)+1 else z:=(!z)-1
let resetZ () = if !z>0 then z:=(-1) else z:=1

let prog i = incZ () ; MKEPos.Prog (i,!z)

let eol r = resetZ () ; [r]


# 93 "parserPolishPosition.ml"
let _eRR =
  Error

let rec _menhir_goto_exp : _menhir_env -> 'ttv_tail -> _menhir_state -> 'tv_exp -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s _v ->
    let _menhir_stack = (_menhir_stack, _menhir_s, _v) in
    match _menhir_s with
    | MenhirState8 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv49 * _menhir_state) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv47 * _menhir_state) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s), _, e) = _menhir_stack in
        let _v : 'tv_exp = 
# 80 "parserPolishPosition.mly"
                (match e with MKEPos.Bexp f -> MKEPos.Bexp (MKE.buildNeg f) | otherwise -> raise (ERROR "The negation operator can only be applied to boolean expressions"))
# 110 "parserPolishPosition.ml"
         in
        _menhir_goto_exp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv48)) : 'freshtv50)
    | MenhirState4 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv53 * _menhir_state) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv51 * _menhir_state) * _menhir_state * 'tv_exp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | B ->
            _menhir_run9 _menhir_env (Obj.magic _menhir_stack) MenhirState12
        | NOT ->
            _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState12
        | ONE ->
            _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState12
        | P ->
            _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState12
        | PLUS ->
            _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState12
        | STAR ->
            _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState12
        | TIMES ->
            _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState12
        | ZERO ->
            _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState12
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState12) : 'freshtv52)) : 'freshtv54)
    | MenhirState12 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv57 * _menhir_state) * _menhir_state * 'tv_exp) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv55 * _menhir_state) * _menhir_state * 'tv_exp) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let (((_menhir_stack, _menhir_s), _, e1), _, e2) = _menhir_stack in
        let _v : 'tv_exp = 
# 73 "parserPolishPosition.mly"
                          (treatPlus e1 e2)
# 151 "parserPolishPosition.ml"
         in
        _menhir_goto_exp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv56)) : 'freshtv58)
    | MenhirState3 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv61 * _menhir_state) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv59 * _menhir_state) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let ((_menhir_stack, _menhir_s), _, e) = _menhir_stack in
        let _v : 'tv_exp = 
# 75 "parserPolishPosition.mly"
                (treatStar e)
# 163 "parserPolishPosition.ml"
         in
        _menhir_goto_exp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv60)) : 'freshtv62)
    | MenhirState2 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv65 * _menhir_state) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv63 * _menhir_state) * _menhir_state * 'tv_exp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | B ->
            _menhir_run9 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | NOT ->
            _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | ONE ->
            _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | P ->
            _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | PLUS ->
            _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | STAR ->
            _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | TIMES ->
            _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | ZERO ->
            _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState15
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState15) : 'freshtv64)) : 'freshtv66)
    | MenhirState15 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv69 * _menhir_state) * _menhir_state * 'tv_exp) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : (('freshtv67 * _menhir_state) * _menhir_state * 'tv_exp) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let (((_menhir_stack, _menhir_s), _, e1), _, e2) = _menhir_stack in
        let _v : 'tv_exp = 
# 74 "parserPolishPosition.mly"
                          (treatTimes e1 e2)
# 204 "parserPolishPosition.ml"
         in
        _menhir_goto_exp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv68)) : 'freshtv70)
    | MenhirState0 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv85 * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        let _tok = _menhir_env._menhir_token in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv83 * _menhir_state * 'tv_exp) = _menhir_stack in
        let (_tok : token) = _tok in
        ((match _tok with
        | EOL ->
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv79 * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv77 * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, r) = _menhir_stack in
            let _v : (
# 65 "parserPolishPosition.mly"
      (MKEPos.ke list)
# 225 "parserPolishPosition.ml"
            ) = 
# 70 "parserPolishPosition.mly"
              (eol r)
# 229 "parserPolishPosition.ml"
             in
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv75) = _menhir_stack in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_v : (
# 65 "parserPolishPosition.mly"
      (MKEPos.ke list)
# 237 "parserPolishPosition.ml"
            )) = _v in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv73) = Obj.magic _menhir_stack in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_v : (
# 65 "parserPolishPosition.mly"
      (MKEPos.ke list)
# 245 "parserPolishPosition.ml"
            )) = _v in
            ((let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv71) = Obj.magic _menhir_stack in
            let (_menhir_s : _menhir_state) = _menhir_s in
            let (_1 : (
# 65 "parserPolishPosition.mly"
      (MKEPos.ke list)
# 253 "parserPolishPosition.ml"
            )) = _v in
            (Obj.magic _1 : 'freshtv72)) : 'freshtv74)) : 'freshtv76)) : 'freshtv78)) : 'freshtv80)
        | _ ->
            assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
            _menhir_env._menhir_shifted <- (-1);
            let (_menhir_env : _menhir_env) = _menhir_env in
            let (_menhir_stack : 'freshtv81 * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
            ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
            _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv82)) : 'freshtv84)) : 'freshtv86)

and _menhir_discard : _menhir_env -> token =
  fun _menhir_env ->
    let lexbuf = _menhir_env._menhir_lexbuf in
    let _tok = _menhir_env._menhir_lexer lexbuf in
    _menhir_env._menhir_token <- _tok;
    _menhir_env._menhir_startp <- lexbuf.Lexing.lex_start_p;
    _menhir_env._menhir_endp <- lexbuf.Lexing.lex_curr_p;
    let shifted = Pervasives.(+) _menhir_env._menhir_shifted 1 in
    if Pervasives.(>=) shifted 0 then
      _menhir_env._menhir_shifted <- shifted;
    _tok

and _menhir_errorcase : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    match _menhir_s with
    | MenhirState15 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv33 * _menhir_state) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv34)
    | MenhirState12 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : ('freshtv35 * _menhir_state) * _menhir_state * 'tv_exp) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s, _) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv36)
    | MenhirState8 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv37 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv38)
    | MenhirState4 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv39 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv40)
    | MenhirState3 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv41 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv42)
    | MenhirState2 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv43 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv44)
    | MenhirState0 ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv45) = Obj.magic _menhir_stack in
        (raise _eRR : 'freshtv46)

and _menhir_run1 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _ = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv31) = Obj.magic _menhir_stack in
    let (_menhir_s : _menhir_state) = _menhir_s in
    ((let _v : 'tv_exp = 
# 77 "parserPolishPosition.mly"
       (MKEPos.(Bexp MKE.Zero))
# 323 "parserPolishPosition.ml"
     in
    _menhir_goto_exp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv32)

and _menhir_run2 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv29 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | B ->
        _menhir_run9 _menhir_env (Obj.magic _menhir_stack) MenhirState2
    | NOT ->
        _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState2
    | ONE ->
        _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState2
    | P ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState2
    | PLUS ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState2
    | STAR ->
        _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState2
    | TIMES ->
        _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState2
    | ZERO ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState2
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState2) : 'freshtv30)

and _menhir_run3 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv27 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | B ->
        _menhir_run9 _menhir_env (Obj.magic _menhir_stack) MenhirState3
    | NOT ->
        _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState3
    | ONE ->
        _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState3
    | P ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState3
    | PLUS ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState3
    | STAR ->
        _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState3
    | TIMES ->
        _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState3
    | ZERO ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState3
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState3) : 'freshtv28)

and _menhir_run4 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv25 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | B ->
        _menhir_run9 _menhir_env (Obj.magic _menhir_stack) MenhirState4
    | NOT ->
        _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState4
    | ONE ->
        _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState4
    | P ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState4
    | PLUS ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState4
    | STAR ->
        _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState4
    | TIMES ->
        _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState4
    | ZERO ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState4
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState4) : 'freshtv26)

and _menhir_run5 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv23 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | INT _v ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv19 * _menhir_state) = Obj.magic _menhir_stack in
        let (_v : (
# 57 "parserPolishPosition.mly"
       (int)
# 428 "parserPolishPosition.ml"
        )) = _v in
        ((let _ = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv17 * _menhir_state) = Obj.magic _menhir_stack in
        let (i : (
# 57 "parserPolishPosition.mly"
       (int)
# 436 "parserPolishPosition.ml"
        )) = _v in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        let _v : 'tv_exp = 
# 78 "parserPolishPosition.mly"
            (prog i)
# 442 "parserPolishPosition.ml"
         in
        _menhir_goto_exp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv18)) : 'freshtv20)
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv21 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv22)) : 'freshtv24)

and _menhir_run7 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _ = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv15) = Obj.magic _menhir_stack in
    let (_menhir_s : _menhir_state) = _menhir_s in
    ((let _v : 'tv_exp = 
# 76 "parserPolishPosition.mly"
      (MKEPos.(Bexp MKE.One))
# 462 "parserPolishPosition.ml"
     in
    _menhir_goto_exp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv16)

and _menhir_run8 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv13 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | B ->
        _menhir_run9 _menhir_env (Obj.magic _menhir_stack) MenhirState8
    | NOT ->
        _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState8
    | ONE ->
        _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState8
    | P ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState8
    | PLUS ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState8
    | STAR ->
        _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState8
    | TIMES ->
        _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState8
    | ZERO ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState8
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState8) : 'freshtv14)

and _menhir_run9 : _menhir_env -> 'ttv_tail -> _menhir_state -> 'ttv_return =
  fun _menhir_env _menhir_stack _menhir_s ->
    let _menhir_stack = (_menhir_stack, _menhir_s) in
    let _tok = _menhir_discard _menhir_env in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv11 * _menhir_state) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | INT _v ->
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv7 * _menhir_state) = Obj.magic _menhir_stack in
        let (_v : (
# 57 "parserPolishPosition.mly"
       (int)
# 509 "parserPolishPosition.ml"
        )) = _v in
        ((let _ = _menhir_discard _menhir_env in
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv5 * _menhir_state) = Obj.magic _menhir_stack in
        let (i : (
# 57 "parserPolishPosition.mly"
       (int)
# 517 "parserPolishPosition.ml"
        )) = _v in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        let _v : 'tv_exp = 
# 79 "parserPolishPosition.mly"
            (MKEPos.(Bexp (MKE.Test i)))
# 523 "parserPolishPosition.ml"
         in
        _menhir_goto_exp _menhir_env _menhir_stack _menhir_s _v) : 'freshtv6)) : 'freshtv8)
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        let (_menhir_env : _menhir_env) = _menhir_env in
        let (_menhir_stack : 'freshtv9 * _menhir_state) = Obj.magic _menhir_stack in
        ((let (_menhir_stack, _menhir_s) = _menhir_stack in
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) _menhir_s) : 'freshtv10)) : 'freshtv12)

and data : (Lexing.lexbuf -> token) -> Lexing.lexbuf -> (
# 65 "parserPolishPosition.mly"
      (MKEPos.ke list)
# 537 "parserPolishPosition.ml"
) =
  fun lexer lexbuf ->
    let _menhir_env =
      let (lexer : Lexing.lexbuf -> token) = lexer in
      let (lexbuf : Lexing.lexbuf) = lexbuf in
      ((let _tok = lexer lexbuf in
      {
        _menhir_lexer = lexer;
        _menhir_lexbuf = lexbuf;
        _menhir_token = _tok;
        _menhir_startp = lexbuf.Lexing.lex_start_p;
        _menhir_endp = lexbuf.Lexing.lex_curr_p;
        _menhir_shifted = 1073741823;
        }) : _menhir_env)
    in
    Obj.magic (let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv3) = () in
    ((assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
    let _tok = _menhir_env._menhir_token in
    let (_menhir_env : _menhir_env) = _menhir_env in
    let (_menhir_stack : 'freshtv1) = _menhir_stack in
    let (_tok : token) = _tok in
    ((match _tok with
    | B ->
        _menhir_run9 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | NOT ->
        _menhir_run8 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | ONE ->
        _menhir_run7 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | P ->
        _menhir_run5 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | PLUS ->
        _menhir_run4 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | STAR ->
        _menhir_run3 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | TIMES ->
        _menhir_run2 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | ZERO ->
        _menhir_run1 _menhir_env (Obj.magic _menhir_stack) MenhirState0
    | _ ->
        assert (Pervasives.(<>) _menhir_env._menhir_shifted (-1));
        _menhir_env._menhir_shifted <- (-1);
        _menhir_errorcase _menhir_env (Obj.magic _menhir_stack) MenhirState0) : 'freshtv2)) : 'freshtv4))



